package com.mygdx.game;

import org.usb4java.Device;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Input.Keys;
import com.badlogic.gdx.math.Vector2;

public class Gun {

	private int x = 300;
	private int y = 50;
	private float rotation = 0;
	private boolean isStop;
	private int maxBalls;
	private int ballsInQueue;
	private int delay;
	private World world;

	final int width = 30;
	final int height = 50;
	final int Scale = 1;
	final int originX = 15;
	final int originY = 15;

	public Gun(World world) {
		
		this.world = world;
		maxBalls = 5;
		ballsInQueue = 0;
		isStop = false;
	}

	public boolean getIsStop() {
		return isStop;
	}
	
	public void setStop(boolean stop) {
		isStop = stop;
	}
	
	public int getMaxBalls () {
		return maxBalls;
	}
	public void increaseMaxBalls () {
		maxBalls++;
	}

	public Vector2 getPosition() {
		return new Vector2(x, y);
	}

	public float getRotation() {
		return rotation;
	}

	public void update(float delta) {
		float rotateSpeed ;
		if (Gdx.input.isKeyPressed(Keys.SHIFT_LEFT) ||  InputManager.getSwitch(InputManager.PORT_SWITCH_SHIFT, InputManager.SWITCH_SHIFT)) {
			rotateSpeed = 0.02f;
		} else {
			rotateSpeed = 1f;
		}
		if (!isStop) {
			if (Gdx.input.isKeyPressed(Keys.LEFT) || InputManager.getSwitch(InputManager.PORT_SWITCH_LEFT, InputManager.SWITCH_LEFT)) {
				rotation += rotateSpeed;
			} else if (Gdx.input.isKeyPressed(Keys.RIGHT) ||  InputManager.getSwitch(InputManager.PORT_SWITCH_RIGHT, InputManager.SWITCH_RIGHT)) {
				rotation -= rotateSpeed;
			}
			if (rotation > 85)
				rotation = 85;
			if (rotation < -85)
				rotation = -85;
		}
			shootBall();
		
	}

	private void shootBall() {
		if (  ballsInQueue == 0 && ! isStop && InputManager.getDelaySwitch(InputManager.PORT_SWITCH_SHOOT, InputManager.SWITCH_SHOOT, 2000) || Gdx.input.isKeyPressed(Keys.SPACE)) {
			ballsInQueue = maxBalls;
			setStop(true);
		}	
		if (ballsInQueue > 0 && delay <= 0) {
			world.shootBall();
			ballsInQueue --;
			delay = 3;
		}
		delay --;
		
	}

	public Vector2 getShootPosition() {
		double radian = Math.toRadians(rotation);
		int x = (int) (this.x + originX - (height - originY) * Math.sin(radian));
		int y = (int) (this.y + originY + (height - originY) * Math.cos(radian));
		return new Vector2(x, y);
	}

}