package com.mygdx.game;

import org.usb4java.Device;
import java.util.Date;

public class InputManager {

	public static int switchCount = 0;
	public static long switchTime[] = new long[10];
	public static McuWithPeriBoard peri;
	public static int sequence[] = {1,2,1,2,3,1,2,3};
	public static boolean disable = false; 
	
	private static int correctIndex;
	private static long errorTime;
	
	public static final int SWITCH_SHOOT = 0;
	public static final int SWITCH_LEFT = 1;
	public static final int SWITCH_RIGHT = 2;
	public static final int SWITCH_SHIFT = 3;
	public static final int SWITCH_Z = 4;
	
	public static final int PORT_SWITCH_SHOOT = 0;
	public static final int PORT_SWITCH_LEFT = 0;
	public static final int PORT_SWITCH_RIGHT = 0;
	public static final int PORT_SWITCH_SHIFT = 0;
	public static final int PORT_SWITCH_Z = 0;

	public static final int PORTB = 0;
	public static final int PORTC = 1;
	public static final int PORTD = 2;
	
	
	public static void start() {
		McuBoard.initUsb();
		Device[] devices = McuBoard.findBoards();
    	
    	if (devices.length == 0) {
            System.out.format("** Practicum board not found **\n");
            return;
    	}
    	else {
            System.out.format("** Found %d practicum board(s) **\n", devices.length);
    	}
        peri = new McuWithPeriBoard(devices[0]);
	}
	
	public static boolean isSwitchJustPress() {
		if (peri.getSwitch()) {
			switchCount++;
				if (switchCount == 0) {
					return true;
				}
		} else {
			switchCount = 0;
		}
		return false;
	}
	
	public static boolean getDelaySwitch(int port, int pin, long delay) {
		if (getSwitch(port, pin) && switchTime[port] <= System.currentTimeMillis( )) {
			switchTime[port] = System.currentTimeMillis( ) + delay;
			return true;
		}
		return false;
	}
	
	public static boolean getSwitch() {
		 return peri.getSwitch();
	}
	
	public static boolean getSwitch(int port, int pin) {
		if (disable){
			return false;
		}
		if (port == PORTB) {
			return peri.getSwitchPortB(pin);
		} else if (port == PORTC) {
			return peri.getSwitchPortC(pin);	
		} else if (port == PORTD) {
			return peri.getSwitchPortD(pin);	
		}
		return false;
	}
	
	public static boolean getSwitchSequence() {
		if (getSwitch(0,sequence[correctIndex])) {
			correctIndex++;
			errorTime = System.currentTimeMillis( )+400;
			if (correctIndex >= sequence.length) {
				correctIndex = 0;
				return true;
			}
		} else if (errorTime < System.currentTimeMillis( )){
			correctIndex = 0;
		}
		return false;
	}
	
	public static void setLedValue(int count) {
		peri.setLedValue(count);
	}
	
	public static void setLed(int ledNo, int value) {
		peri.setLed((short)ledNo, (short)value);
	}
	
}
