#include <avr/io.h>
#include "peri.h"

void init_peripheral()
{
 	DDRC |= (1<<PC0)|(1<<PC1)|(1<<PC2);
	PORTC &= ~((1<<PC0)|(1<<PC1)|(1<<PC2));
	DDRC &= ~(1<<PC3);
	PORTC |= (1 << PC3);
	DDRC &= ~(1<<PC4);
	PORTC &= ~(1 << PC4);

	DDRB &= ~(1<<PC0);
	PORTB |= (1 << PC0);
	DDRB &= ~(1<<PC1);
	PORTB |= (1 << PC1);
	DDRB &= ~(1<<PC2);
	PORTB |= (1 << PC2);
	DDRB &= ~(1<<PC3);
	PORTB |= (1 << PC3);
	DDRB &= ~(1<<PC4);
	PORTB |= (1 << PC4);
	DDRB &= ~(1<<PC5);
	PORTB |= (1 << PC5);

}

void set_led(uint8_t pin, uint8_t state)
{
 	if (state == 1) {
		PORTC |= (1 << pin);
	} else {
		PORTC &= ~(1 << pin);
	}
}

void set_led_value(uint8_t value)
{
 	PORTC &= ~(0b111);
	PORTC |= (value & 0b00000111);
}

uint16_t read_adc(uint8_t channel)
{
	ADMUX = (0 << REFS1) | (1 << REFS0) | (0 << ADLAR) | (channel & 0b1111);
	ADCSRA = (1 << ADEN) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0) 
		| (1 << ADSC);
	while ((ADCSRA & (1 << ADSC)))
		;
	return ADCL + ADCH*256;
}

uint16_t get_light()
{
	uint16_t result = read_adc(PC4);
	return result;
}
 
uint8_t get_switch_portC(uint8_t pin) {
	return (PINC & (1 << pin)) == 0;
}

uint8_t get_switch_portB(uint8_t pin) {
	return (PINB & (1 << pin)) == 0;
}

uint8_t get_switch_portD(uint8_t pin) {
	return (PIND & (1 << pin)) == 0;
}

